<?php
# It is the context of the subscription, in which a customer can manage its VPSes.
# It must correspond to a tenant created for the subscriber in the remote application system.
require "aps/2/runtime.php";	

/**
* Class context
* @type("http://aps-standard.org/samples/sample-dns/context/1.0")
* @implements("http://aps-standard.org/types/core/subscription/service/1.0")
*/
class context extends \APS\ResourceBase
{
	## Strong relation (link) to the application instance		
	/**
	* @link("http://aps-standard.org/samples/sample-dns/cloud/1.0")
	* @required
	*/
	public $cloud;
	
	## Collection of relations with domains
	/**
	* @link("http://aps-standard.org/types/dns/domain/1.0[]")
	*/
	public $paDomains;
	
	## Weak relation (link) to collection of VPSes
	/**
	 * @link("http://aps-standard.org/samples/sample-dns/vps/1.0[]")
	 */
	public $vpses;
		
	## Event handler
	/**
	 * @verb(POST)
	 * @path("/onBindToDomain")
	 * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
	 */
	public function onBindToDomain($domainNotification) {
		\APS\LoggerRegistry::get()->info("Domain bound: ".json_format($domainNotification));
		
		// Connect to the APS controller
		$apsc2 = \APS\Request::getController();
		$apsc = $apsc2->impersonate($this);
		$domain = $apsc->getResource($domainNotification->parameters->domain->id);
		$apsc->linkResource($this,'paDomains',$domain);
	}

	public function provision() {
	
		#### Connect to the APS controller
		$apsc = \APS\Request::getController();
		if ($apsc == null) {
			error_log("apsc is null");
		}
		
		#### Subscription to the "bind to domain" event
		$subBindToDomain = new \APS\EventSubscription(\APS\EventSubscription::BindServicesToDomain, "onBindToDomain");
		
		#### Create event source class
		$subBindToDomain->source = new stdClass();

		#### Activate the subscription
		$subBindToDomain->source->id=$this->subscription->aps->id;
		$apsc->subscribe($this, $subBindToDomain);
	}
	
}
?>
